<script setup lang="ts">
const props = defineProps<{ term: string }>();

const { search: searchByOrthology } = useGeneService();
const { search: searchByPhenotypes } = usePhenotypeService();

const colorScale = createColorScale("#DD2C00", "#4CAF50", 10);

const itemsPerPage = ref(10);
const penetrance = ref(0.8);
const page = ref(1);
const headers = [
  {
    title: "Gene",
    key: "gene",
    sortable: false,
  },
  {
    title: "Phenotypes",
    key: "phenotypes",
    sortable: false,
  },
];

const itemsPerPageOptions = [
  { value: 10, title: "10" },
  { value: 25, title: "25" },
  { value: 50, title: "50" },
  { value: 100, title: "100" },
];

const { data, pending, error } = await useAsyncData(
  () =>
    Promise.all([
      searchByOrthology(props.term),
      searchByPhenotypes(
        props.term,
        penetrance.value,
        itemsPerPage.value * (page.value - 1),
        itemsPerPage.value,
      ),
    ]),
  {
    watch: [() => props.term, itemsPerPage, page, penetrance],
  },
);
const orthologyData = computed(() => data.value?.[0]);
const phenotypeData = computed(() => data.value?.[1]);

const genes = computed(() => orthologyData.value?.genes);
const orthologies = computed(() => orthologyData.value?.orthologies);
const otherGenes = computed(() => orthologyData.value?.otherGenes);

const tab = ref<string>();

const directHitBadge = computed(() => genes.value?.length || 0);
const phenotypeBadge = computed(() => phenotypeData.value?.total || 0);
const orthologyBadge = computed(
  () => (orthologies.value?.length || 0) + (otherGenes.value?.length || 0),
);

watch(
  genes,
  async (newGenes) => {
    if (newGenes && newGenes.length === 1) {
      await navigateTo({ path: `/details/${newGenes[0]}`, replace: true });
    }
  },
  {
    immediate: true,
  },
);

watch(
  [phenotypeBadge, orthologyBadge],
  () => {
    if (tab.value === undefined) {
      if (directHitBadge.value) {
        tab.value = "Direct";
      } else if (orthologyBadge.value) {
        tab.value = "Orthology";
      } else if (phenotypeBadge.value) {
        tab.value = "Phenotype";
      }
    }
  },
  { immediate: true },
);
</script>
<template>
  <WarningAlert v-if="error" text="Failed to load search results" />
  <template v-else>
    <client-only>
      <v-tabs v-model="tab" color="primary">
        <v-tab value="Direct">
          Direct hits
          <v-badge color="primary" :content="directHitBadge" inline />
        </v-tab>
        <v-tab value="Orthology"
          >By orthology
          <v-badge color="primary" :content="orthologyBadge" inline
        /></v-tab>
        <v-tab value="Phenotype"
          >By phenotype
          <v-badge color="primary" :content="phenotypeBadge" inline
        /></v-tab>
      </v-tabs>
      <v-window v-model="tab" class="pt-4">
        <v-window-item key="Direct" value="Direct">
          <div v-if="genes && genes.length">
            <div v-for="gene in genes" :key="gene" class="ml-4">
              <IBBGeneId :gene="gene" />
            </div>
            <div v-if="genes.length == 1" class="mb-4 mt-4 font-italic">
              Redirecting to gene details page...
            </div>
          </div>
          <div v-else>No results found</div>
        </v-window-item>
        <v-window-item key="Orthology" value="Orthology">
          <div v-if="orthologies && orthologies.length">
            <SearchResultGeneOrthology :orthologies="orthologies" />
          </div>
          <div v-else-if="otherGenes && otherGenes.length" class="ml-4">
            <div class="mb-4">Found <i>Drosophila</i> genes:</div>
            <div
              v-for="{ gene, species } in otherGenes"
              :key="gene"
              class="ml-4"
            >
              <FlybaseGeneId v-if="species === 'Dmel'" :gene="gene" />
              <div v-else>{{ gene }}</div>
            </div>
            <div class="mb-4 mt-4">
              which have no orthologous gene in <i>Tribolium</i>.
            </div>
          </div>
          <div v-else>No results found</div>
        </v-window-item>
        <v-window-item key="Phenotype" value="Phenotype">
          <div class="d-flex ml-2 pt-8" style="max-width: 600px">
            <v-slider
              v-model="penetrance"
              label="Penetrance:"
              :min="0.1"
              :max="1"
              step="0.1"
              show-ticks="always"
              thumb-label="always"
              :color="colorScale[penetrance * 10 - 1]"
              track-color="grey"
            >
              <template #thumb-label="{ modelValue }">
                &ge;{{ modelValue * 100 }}%
              </template>
            </v-slider>
          </div>
          <v-data-table-server
            v-model:items-per-page="itemsPerPage"
            :items-per-page-options="itemsPerPageOptions"
            :items-length="(phenotypeData && phenotypeData.total) || 0"
            :headers="headers"
            :loading="pending"
            :items="(phenotypeData && phenotypeData.data) || []"
            @update:options="
              (options) => (
                (page = options.page), (itemsPerPage = options.itemsPerPage)
              )
            "
          >
            <template #item.gene="{ item }">
              <IBBGeneId :gene="item.gene" />
            </template>
            <template #item.phenotypes="{ item }">
              <template
                v-for="phenotype in item.phenotypes"
                :key="phenotype.id"
              >
                <PhenotypeItem
                  :phenotype="phenotype"
                  variant="mini"
                  :image-height="100"
                />
              </template>
            </template>
          </v-data-table-server>
        </v-window-item> </v-window
    ></client-only>
  </template>
</template>
